ARG CAR_OCI_REGISTRY_HOST=artefact.skao.int

FROM artefact.skao.int/ska-tango-images-pytango-builder:9.5.0 AS buildenv
FROM artefact.skao.int/ska-tango-images-pytango-runtime:9.5.0 AS runtime

# Copy poetry.lock* in case it doesn't exist in the repo
COPY pyproject.toml poetry.lock* ./

USER root

RUN pip install poetry==1.8.3
RUN pip install poetry-plugin-export && \
    poetry config warnings.export false

# Install runtime + developer dependencies
RUN poetry export --format requirements.txt --output poetry-requirements.txt --without-hashes --with dev && \
    pip install -r poetry-requirements.txt && \
    rm poetry-requirements.txt && \
    pip install .

USER tango

# give poetry access to system pytango installation and don't try to install/update
# packages in system site-packages. This configuration should only affect developers
# running 'poetry update' in an interactive session.
RUN poetry config virtualenvs.create true
# Enable with poetry 1.2.0
#    poetry config virtualenvs.options.system-site-packages true

# Important! This ARG has to come AFTER the FROM statements, not before. If you put the
# ARG statement above FROM then PIP_INDEX_URL is set to a blank value and we default to
# the pypi host set in pip.conf.
ARG CAR_PYPI_REPOSITORY_URL=https://artefact.skao.int/repository/pypi-internal
ENV PIP_INDEX_URL ${CAR_PYPI_REPOSITORY_URL}/simple

ENV PATH="/home/tango/.local/bin:${PATH}"

CMD ["python3"]
